<?php

namespace App\Services\Part;

use App\Entities\Equipment\LineEntity;
use App\Entities\Equipment\ServerEntity;
use App\Entities\Equipment\ServerPartEntity;
use App\Entities\Part\IPEntity;
use App\Forms\Part\IPForm;
use App\Helpers\Part\IPHelper;
use App\Models\Part\IPModel;
use RuntimeException;

class IPService extends PartType3Service
{
    protected string $formClass = IPForm::class;
    protected string $helperClass = IPHelper::class;

    public function __construct(IPModel $model)
    {
        parent::__construct($model);
        $this->addClassPaths('IP');
    }
    public function getEntityClass(): string
    {
        return IPEntity::class;
    }
    //기본 기능부분
    protected function getEntity_process(mixed $entity): IPEntity
    {
        return $entity;
    }
    protected function create_process(array $formDatas): IPEntity
    {
        //IP 기본비용정의
        if (!array_key_exists('price', $formDatas)) {
            $formDatas['price'] = IP['DEFAULT_PRICE'];
        }
        //IP 등록
        $entity = parent::create_process($formDatas);
        if (!$entity instanceof IPEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생:Return Type은 IPEntity만 가능");
        }
        return $entity;
    }
    //List 검색용
    //FormFilter 조건절 처리
    //검색어조건절처리
    //OrderBy 처리(INET_ATON() 함수를 사용)
    public function setOrderBy(mixed $field = null, mixed $value = null): void
    {
        $this->model->orderBy("INET_ATON(ip) ASC");
        parent::setOrderBy($field, $value);
    }
    //Line관련 작업
    public function attachToLine(LineEntity $lineEntity, string $ip): IPEntity
    {
        $entity = $this->create_process([
            'lineinfo_uid' => $lineEntity->getPK(),
            'ip' => $ip,
            'status' => STATUS['AVAILABLE'],
        ]);
        if (!$entity instanceof IPEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 {$lineEntity->getTitle()}의 {$ip} 생성을 실패하였습니다.");
        }
        return $entity;
    }
    //서버관련 작업
    //파트정보가져오기
    public function getPartEntityByServer(ServerEntity $serverEntity, array $formDatas = []): IPEntity
    {
        //IP정보에서 해당하는 IP가 있으면 가져와서 사용중인지 체크 후 수정
        $entity = $this->getEntity(['ip' => $serverEntity->getIP()]);
        if (!$entity instanceof IPEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 {$serverEntity->getIP()}에 해당하는 IP정보를 찾을수없습니다.");
        }
        return $entity;
    }
    public function detachFromServer(ServerEntity $serverEntity, array $formDatas = []): IPEntity
    {
        /** @var IPEntity $entity IDE에 entity type알려주기*/
        $entity = $this->getPartEntityByServer($serverEntity);
        $formDatas['old_clientinfo_uid'] = $entity->getClientInfoUid() ?? $serverEntity->getClientInfoUid();
        $entity = parent::detachFromServer($serverEntity, $formDatas);
        if (!$entity instanceof IPEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 {$serverEntity->getIP()}에 해당하는 IP정보를 찾을수없습니다.");
        }
        return $entity;
    }
    //서버파트관련 작업
    //파트정보가져오기
    public function getPartEntityByServerPart(ServerPartEntity $serverPartEntity): IPEntity
    {
        //IP정보에서 해당하는 IP가 있으면 가져와서 사용중인지 체크 후 수정
        $entity = $this->getEntity($serverPartEntity->getPartUid());
        if (!$entity instanceof IPEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 {$serverPartEntity->getPartUid()}에 해당하는 IP정보를 찾을수없습니다.");
        }
        return $entity;
    }
    //사용했던 고객정보 남기기위해 추가
    public function detachFromServerPart(ServerPartEntity $serverPartEntity, array $formDatas = []): IPEntity
    {
        /** @var IPEntity $entity IDE에 entity type알려주기*/
        $entity = $this->getPartEntityByServerPart($serverPartEntity);
        $formDatas['old_clientinfo_uid'] = $entity->getClientInfoUid();
        $entity = parent::detachFromServerPart($serverPartEntity, $formDatas);
        if (!$entity instanceof IPEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 {$serverPartEntity->getPartUid()}에 해당하는 IP정보를 찾을수없습니다.");
        }
        return $entity;
    }
}
